/*
 *  TOPPERS/JSP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Just Standard Profile Kernel
 * 
 *  Copyright (C) 2010 by Meika Sugimoto
 *
 *  嵭Ԥϡʲ (1)(4) ξ狼Free Software Foundation 
 *  ˤäƸɽƤ GNU General Public License  Version 2 ˵
 *  ҤƤ˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơŬѲǽ
 *  ޤơʤݾڤԤʤޤܥեȥѤˤľ
 *  ŪޤϴŪʤ»˴ؤƤ⡤Ǥʤ
 * 
 */

/*
 *  åȰ¸⥸塼CQ_V850ѡ
 */

#include "kernel_impl.h"
#include <sil.h>
#include "cq_v850.h"

/* ХʡѤΥꥢݡȽ */
static void target_fput_initialize(void);

/*
 *  åȰ¸ν
 */
void
target_initialize(void)
{
	uint16_t wr_mem_h;
	uint32_t wr_mem_w;
	
	/*
	 *	ץå¸ν
	 */
	prc_initialize();

	/*
	 * ХʡѤΥꥢ륳ȥν
	 */
	target_fput_initialize();
	
	/*
	 *	LED³ݡȤ
	 */
	clr_bit(LED1_BITPOS , LED1_ADDRESS);
	clr_bit(LED1_BITPOS , PCMT);
	
	/*
	 * UART0I/OݡȤ
	 *
	 * P30P31ǽ꤬ɬ(PMC3 , PFC3)
	 */
	wr_mem_h = (sil_reh_mem((void *)PMC3L) & 0xfffc) | 0x003;
	sil_wrh_mem((void *)PMC3L, wr_mem_h);
	wr_mem_w = (sil_reh_mem((void *)PFC3) & 0xfffc);
	sil_wrh_mem((void *)PFC3, wr_mem_w);
}

/*
 *  åȰ¸νλ
 */
void
target_exit(void)
{
	volatile uint_t i = 1;
	
	/*
	 *	ץå¸νλ
	 */
	prc_terminate();

	/*
	 *	ˤʤ
	 *	
	 *	ѿivolatileΤϡŬˤ
	 *	롼פΤɤᡣ
	 */
	while(i)
		;
}

static void target_fput_initialize(void)
{
	/* ưػ */
	clr_bit(7 , UA0CTL0);
	
	/* ⡼ɡܡ졼 */
	sil_wrb_mem((void *)UA0CTL1 , TARGET_FPUTC_UAnCTL1_SETTING);
	sil_wrb_mem((void *)UA0CTL2 , TARGET_FPUTC_UAnCTL2_SETTING);
	
	/* ΤߵġLSBեȡȥåץӥå1bit8bitĹѥƥʤ */
	sil_wrb_mem((void *)UA0CTL0 , 0xD2);
}

/*
 *  ƥ٥ϤΤʸ
 */
void
target_fput_log(char_t c)
{
	if (c == '\n') {
		while((sil_reb_mem((void *)TARGET_FPUTC_UAnSTR) & 0x80) != 0x00)
			;
		sil_wrb_mem((void *)TARGET_FPUTC_UAnTX , '\r');
	}
	while((sil_reb_mem((void *)TARGET_FPUTC_UAnSTR) & 0x80) != 0x00)
		;
	sil_wrb_mem((void *)TARGET_FPUTC_UAnTX , c);
}
